#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>


  /*  ɥǡ  */
static char drum_data1[] = { 4,3,1,4,0,5,1,4,3,1,4,0,5,1,4,2,1,4,0,5,1 };
static char drum_data2[] = { 4,3,0,2,5,2,3,0,1,5,4,3,0,0,5,2,3,0,0,3,5 };
static char drum_data3[] = { 4,2,5,0,3,1,5,0,3,1,5,0,3,1,5,0,3,1,5,0,3 };

  /*  ̥ǡ  */
struct screen {
  Display *d;
  Window w;
  GC gc;
  Font f;
  XSetWindowAttributes a;
  Pixmap slot, icon;
};

  /*  ǡ  */
struct mouse {
  Colormap cm;
  Pixmap finger, mask;
  XColor c1, c2, cc;
  Cursor cs;
  int mouse_x, mouse_y;
};

  /*  ɥǡ  */
struct drum {
  char drum[3][21];
  Pixmap mark[6];   /*  apple, bell, bar, cherry, seven, suika;  */
  int point[3];     /*  ƤȤ    */
  char atari[3];    /*  äƤȤ  */
  int speed[3];     /*  ޤäƤϤ䤵  */
  Pixmap black;
  int stop[3];
  int stop_flag[3];
  int wait[3];
};

  /*  ǡ  */
struct medal {
  unsigned long int money;
  int point;
  Pixmap medal, black;
  char moji[7];
};

  /*  ؤʤ礳ǡ 
struct henachoko {
  unsigned int width, height;
  int xhot, yhot;
};
*/


  /*  ʸ󥳥ԡ  */
ishida_strcpy( char *s, char *t )
{
  int i, j;

  i = 0;
  while ( s[i] ) i++;
  j = 0;
  while ( t[j] ) s[i+j] = t[j++];
  s[j+i] = 0;
}

  /*  ǥ쥯ȥ꡼ȥե̾Τƥեѥˤ  */
set_file_name( char *s, char *t, char *u )
{
  s[0] = 0;
  ishida_strcpy( s, t );
  ishida_strcpy( s, u );
}

  /*  ɥ  */
init_window( struct screen *s, char *xbm_dir )
{
  unsigned int width, height;
  int xhot, yhot;
  XWMHints wmh;
  XSizeHints xsh;
  char icon_file[100], slot_file[100];

  s->d = XOpenDisplay( NULL );
  s->w = XCreateSimpleWindow( s->d, RootWindow( s->d, 0 ), 100, 100,
			  140, 200, 2, 0, 1);
  s->a.backing_store = Always;
  s->a.event_mask = ExposureMask | ButtonPressMask;
  s->a.bit_gravity = CenterGravity;
  XChangeWindowAttributes( s->d, s->w, CWEventMask | CWBackingStore, &(s->a) );
  XSelectInput( s->d, s->w, ButtonPress | ButtonRelease );

  set_file_name( icon_file, xbm_dir, "icon.xbm" );
  XReadBitmapFile( s->d, s->w, icon_file,
                  &width, &height, &(s->icon), &xhot, &yhot );
  XStoreName( s->d, s->w, "SLOT" );
  wmh.flags = IconPositionHint | IconPixmapHint;
  wmh.initial_state = IconicState;
  wmh.icon_x = 900;
  wmh.icon_y = 50;
  wmh.icon_pixmap = s->icon;
  XSetWMHints( s->d, s->w, &wmh );

  xsh.flags = PMinSize | PMaxSize;
  xsh.min_width = 140;
  xsh.min_height = 200;
  xsh.max_width = 140;
  xsh.max_height = 200;
  XSetNormalHints( s->d, s->w, &xsh );

  XMapWindow( s->d, s->w );
  s->gc = XCreateGC( s->d, s->w, 0, 0 );

  s->f = XLoadFont( s->d,
   "-b&h-lucidatypewriter-bold-r-normal-sans-18-160-75-*-m-103-iso8859-1" );
  XSetFont( s->d, s->gc, s->f );

  set_file_name( slot_file, xbm_dir, "slot.xbm" );
  XReadBitmapFile( s->d, s->w, slot_file,
                  &width, &height, &(s->slot), &xhot, &yhot );
}

  /*  ɥ  */
draw_window( struct screen *s )
{
  XDrawString( s->d, s->w, s->gc,  0, 160, " Slot Machine ", 14 );
  XDrawString( s->d, s->w, s->gc, 10, 175, "Medal:", 6 );
  XDrawString( s->d, s->w, s->gc,  0, 190, "[START]", 7 );
  XDrawString( s->d, s->w, s->gc, 80, 190, "[QUIT]", 6 );

  XSetFillStyle( s->d, s->gc, FillStippled );
  XSetStipple( s->d, s->gc, s->slot );
  XFillRectangle( s->d, s->w, s->gc, 0, 0, 140, 140 );
  
  XFlush( s->d );
}

  /*  ޥꤹ  */
init_mouse( struct screen *s, struct mouse *m, char *xbm_dir )
{
  unsigned int width, height;
  int xhot, yhot;
  char finger_file[100], mask_file[100];

  set_file_name( finger_file, xbm_dir, "finger.xbm" );
  XReadBitmapFile( s->d, s->w, finger_file,
                  &width, &height, &(m->finger), &xhot, &yhot );
  set_file_name( mask_file, xbm_dir, "mask.xbm" );
  XReadBitmapFile( s->d, s->w, mask_file,
                  &width, &height, &(m->mask), &xhot, &yhot );
  m->cm = DefaultColormap( s->d, 0 );
  XAllocNamedColor( s->d, m->cm, "black", &(m->c1), &(m->cc));
  XAllocNamedColor( s->d, m->cm, "white", &(m->c2), &(m->cc));
  m->cs = XCreatePixmapCursor( s->d, m->finger, m->mask,
			      &(m->c1), &(m->c2), 0, 0 );
  XDefineCursor( s->d, s->w, m->cs );

  XFlush( s->d );
}

  /*  ɥ  */
init_drum( struct screen *s, struct drum *d, char *xbm_dir )
{
  unsigned int width, height;
  int xhot, yhot;
  char filename[6][100];

  int i;

  for (  i=0; i<21; i++ ) {
    d->drum[0][i] = drum_data1[i];
    d->drum[1][i] = drum_data2[i];
    d->drum[2][i] = drum_data3[i];
  }

  set_file_name( &filename[0][0], xbm_dir, "apple.xbm" );
  XReadBitmapFile( s->d, s->w, &filename[0][0],
                  &width, &height, &(d->mark[0]), &xhot, &yhot );
  set_file_name( &filename[1][0], xbm_dir, "bell.xbm" );
  XReadBitmapFile( s->d, s->w, &filename[1][0],
                  &width, &height, &(d->mark[1]), &xhot, &yhot );
  set_file_name( &filename[2][0], xbm_dir, "bar.xbm" );
  XReadBitmapFile( s->d, s->w, &filename[2][0],
                  &width, &height, &(d->mark[2]), &xhot, &yhot );
  set_file_name( &filename[3][0], xbm_dir, "cherry.xbm" );
  XReadBitmapFile( s->d, s->w, &filename[3][0],
                  &width, &height, &(d->mark[3]), &xhot, &yhot );
  set_file_name( &filename[4][0], xbm_dir, "seven.xbm" );
  XReadBitmapFile( s->d, s->w, &filename[4][0],
                  &width, &height, &(d->mark[4]), &xhot, &yhot );
  set_file_name( &filename[5][0], xbm_dir, "suika.xbm" );
  XReadBitmapFile( s->d, s->w, &filename[5][0],
                  &width, &height, &(d->mark[5]), &xhot, &yhot );
  
  for ( i=0; i<3; i++ ) {
    d->point[i] = 16;
    d->speed[i] = 0;
    d->atari[i] = 20;
    d->stop[i] = 0;
    d->stop_flag[i] = 1;
  }
}

  /*  ν  */
init_medal( struct screen *s, struct medal *md, char *xbm_dir )
{
  unsigned int i, width, height;
  int xhot, yhot;
  char medal_file[100], black_file[100];

  md->money = 100;
  md->point = 0;
  set_file_name( medal_file, xbm_dir, "medal.xbm" );
  XReadBitmapFile( s->d, s->w, medal_file,
                  &width, &height, &(md->medal), &xhot, &yhot );
  set_file_name( black_file, xbm_dir, "black.xbm" );
  XReadBitmapFile( s->d, s->w, black_file,
                  &width, &height, &(md->black), &xhot, &yhot );

  for ( i=0; i<7; i++ ) md->moji[i] = '0';
}  

  /*  饯ɽؿ  */
put_char( int x, int y, int width, int heigh, int zx, int zy, char z,
	 struct screen *win, Pixmap *bitmap )
{
  unsigned black, white;
  Colormap cmap;
  XColor c0, c1;

  cmap = DefaultColormap( win->d, 0 );
  if ( z==1 )
    XAllocNamedColor( win->d, cmap, "white", &c1, &c0 );
  else
    XAllocNamedColor( win->d, cmap, "black", &c1, &c0 );
  XSetForeground( win->d, win->gc, c1.pixel );

  XSetTSOrigin( win->d, win->gc, zx, zy );
  XSetFillStyle( win->d, win->gc, FillOpaqueStippled );
  XSetStipple( win->d, win->gc, *bitmap );
  XFillRectangle( win->d, win->w, win->gc, x, y, width, heigh );
}

  /*  ɥɽ  */
drum_flush( struct screen *win, struct drum *drm )
{
  int i, j, z, a, b, c, ma, mb, mc;

  for ( i=0; i<3; i++ ) {

    a = (drm->atari[i]) % 21;
    b=(a+1)%21;
    c=(a+2)%21;
    
    ma = drm->drum[i][c];
    mb = drm->drum[i][b];
    mc = drm->drum[i][a];

    put_char( i*38+24, 30, 32, drm->point[i],
	     i*38+24, drm->point[i]-2, 1, win, &(drm->mark[ma]));
    put_char( i*38+24, drm->point[i]+30, 32, 32,
	     i*38+24, drm->point[i]-2, 1, win, &(drm->mark[mb]));
    put_char( i*38+24, drm->point[i]+62, 32, (32-(drm->point[i])),
	     i*38+24, drm->point[i]-2, 1, win, &(drm->mark[mc]));
    
    if ( (32-(drm->speed[i]))>(drm->point[i]) ) {
      drm->point[i]+=drm->speed[i];
    }
    else {
      drm->point[i]=0;
      if ( (drm->atari[i])<21 ) drm->atari[i]++; 
      else drm->atari[i]=0;
    }
  }
  XFlush( win->d );
}

  /*  ɽ  */
draw_medal( struct screen *scr, struct medal *mdl )
{
  int i, s, x;
  unsigned black, white;
  Colormap cmap;
  XColor c0, c1;

  cmap = DefaultColormap( scr->d, 0 );
  XAllocNamedColor( scr->d, cmap, "black", &c1, &c0 );
  XSetForeground( scr->d, scr->gc, c1.pixel );

  XSetTSOrigin( scr->d, scr->gc, 0, 0 );
  XSetFillStyle( scr->d, scr->gc, FillStippled );
  XSetStipple( scr->d, scr->gc, mdl->black );
  XFillRectangle( scr->d, scr->w, scr->gc, 70, 161, 70, 15 );

  x = mdl->money;
  i = 1000000;
  s = 0;
  while ( i!=0 ){
    mdl->moji[s] = x / i + '0';
    x = x % i;
    i = i / 10;
    s ++;
  }

  XAllocNamedColor( scr->d, cmap, "white", &c1, &c0 );
  XSetForeground( scr->d, scr->gc, c1.pixel );
  XDrawString( scr->d, scr->w, scr->gc, 70, 175, &(mdl->moji[0]), 7 );

  XSetTSOrigin( scr->d, scr->gc, 24, mdl->point%32 );
  XSetFillStyle( scr->d, scr->gc, FillOpaqueStippled );
  XSetStipple( scr->d, scr->gc, mdl->medal );
  XFillRectangle( scr->d, scr->w, scr->gc, 24, 102, 108, 32 );
  
  XFlush( scr->d );
}
  
  /*  뤬Ǥʤʤä...  */
int zero_money( struct medal *m )
{
  if ( m->money<3 ) return 0; else  return 1;
}

  /*  ܥΥå  */
int sq_check( struct screen *scr )
{
  Window etc1, etc2;
  unsigned int mask;
  int mx, my, rx, ry;
  XEvent e;

  do {
    do {
      XNextEvent( scr->d, &e );
    } while (!(e.type==ButtonPress));
    mx = e.xbutton.x;
    my = e.xbutton.y;
  } while (!(( mx>0 && mx<60 && my>180 && my<190 ) ||
	   ( mx>80 && mx<130 && my>180 && my<190)));

  if ( mx>0   && mx<60 ) return 1;
  if ( mx>80 && mx<130 ) return 2;
}

  /*  ॹ  */
start_game( struct screen *scr, struct drum *drm, struct medal *mdl )
{
  int i, z;

  for ( i=0; i<3; i++ ) {
    drm->speed[i] = 24;
    drm->stop[i] = 0;
    drm->stop_flag[i] = 1;
    drm->wait[i] = 0;
    mdl->money -= 1;
    mdl->point++;
    draw_medal( scr, mdl );
    usleep( 10000 );
  }
}

  /*  ɥβž  */
roll_drum( struct screen *scr, struct drum *drm )
{
  Window etc1, etc2;
  unsigned int mask;
  int mx, my, rx, ry, i;

  do {
    drum_flush( scr, drm );
    
    XQueryPointer( scr->d, scr->w, &etc1, &etc2, &rx, &ry, &mx, &my, &mask );
    if ( my<140 ) {
      if ( mask & Button1Mask && 19<mx && mx<51 ) {
	drm->stop[0] = 1;
      }
      if ( mask & Button1Mask && 57<mx && mx<90 ) {
	drm->stop[1] = 1;
      }
      if ( mask & Button1Mask && 94<mx && mx<128 ) {
	drm->stop[2] = 1;
      }
    }
    for ( i=0; i<3; i++ ) {
      if ( drm->stop[i]==1 ) {
	if ( drm->speed[i]>0 && drm->wait[i]==0 ) drm->speed[i]--;
	if ( drm->speed[i]<=0 ) drm->stop_flag[i]=0; else drm->stop_flag[i]=1;
	drm->wait[i]++; drm->wait[i] %= 2;
      }
    }
  } while ( drm->stop_flag[0] || drm->stop_flag[1] || drm->stop_flag[2] );  

  for ( i=0; i<3; i++ ) {
    while ( drm->point[i]>16 ) {
      drm->point[i]--;
      drum_flush( scr, drm );
    }
    while ( drm->point[i]<16 ) {
      drm->point[i]++;
      drum_flush( scr, drm );
    }
  }
}

  /*  Ƚ  */
int atari_check( a, b, c )
{
  int d;

  d = 0;
  if ( b==5 ) d=1;
  if ( a==3 ) d=2;
  if ( a==b && b==3 ) d=3;
  if ( a==b && b==c ) d=8;
  if ( a==b && b==c && c==3 ) d=5;
  if ( a==0 && c==0 ) d=10;
  if ( a==b && b==c && c==1 ) d=15;
  if ( a==b && b==c && c==2 ) d=18;
  if ( a==b && b==c && c==4 ) d=20;

  return d * 3;
}

  /*  βû  */
medal_plus( int d, struct screen *scr, struct medal *mdl )
{
  int i, j, z;

  for ( i=0; i<d; i++ ) {
    for ( j=0; j<5; j++ ) {	
      mdl->point--;
      draw_medal( scr, mdl );
    }
    if ( mdl->money < 9999999 ) mdl->money++;
    draw_medal( scr, mdl );
  }
   draw_medal( scr, mdl );
}

  /*  μ¹  */
game( struct screen *scr, struct drum *drm, struct medal *mdl )
{
  int a, b, c, d, i, z, ck1, ck2, ck3;

  if ( sq_check( scr )==1 ) {
    do {
      start_game( scr, drm, mdl );
      
      roll_drum( scr, drm );

      ck1 = (drm->atari[0]+1)%21;
      ck2 = (drm->atari[1]+1)%21;
      ck3 = (drm->atari[2]+1)%21;
      
      a = drm->drum[0][ck1];
      b = drm->drum[1][ck2];
      c = drm->drum[2][ck3]; 
      
      d = atari_check( a, b, c );

      medal_plus( d, scr, mdl );

      if ( d>=45 ) {
	for ( i=0; i<10; i++ ) {
	  while ( sq_check( scr )==1 ) {
	    start_game( scr, drm, mdl );
	    roll_drum( scr, drm );
	    a = drm->drum[0][drm->atari[0]+1]+1;
	    b = drm->drum[1][drm->atari[1]+1]+1;
	    c = drm->drum[2][drm->atari[2]+1]+1; 
	    z = ( a + b + c ) * ( d / 3 - 14 );
	    medal_plus( z, scr, mdl );
	  }
	}
      }
      
    } while  ( sq_check( scr )==1 && zero_money( mdl ) );
  }

  if ( zero_money( mdl ) ) printf(" See You Again. (^^)/~\n");
  else printf(" You are lost. (;_;)");
}

  /*  Τμ¹  */
main( int argc, char *argv[] )
{
  struct screen screen;
  struct mouse mouse;
  struct drum drum;
  struct medal medal;
/*  struct henachoko henachoko;
*/
  char xbm_file[6][100];
  char xbm_dir[100] = "./bitmap/";
  int i;

  if ( argc > 1 ) {
    i = 0;
    while ( argv[1][i] ) {
      xbm_dir[i]=argv[1][i];
      i ++;
    }
    xbm_dir[i] = 0;
    ishida_strcpy( xbm_dir, "/" );
  }

  init_window( &screen, xbm_dir );
  init_mouse( &screen, &mouse, xbm_dir );
  init_drum( &screen, &drum, xbm_dir );
  init_medal( &screen, &medal, xbm_dir );
  draw_window( &screen );
  drum_flush( &screen, &drum );
  draw_medal( &screen, &medal );

  printf(" Slot Machine Version 2\n");
  printf(" Ishida Yoshiteru. Kurume Institute of Technorogy.\n");
  printf(" E-mail address e924202@ed.kurume-it.ac.jp\n");
   
  game( &screen, &drum, &medal );

  printf(" Good Bye..\n");
}
